<?php
/******************************************************************************
* 2co.php                                                                     *
*******************************************************************************
* SMF: Simple Machines Forum                                                  *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1 Beta 4                                  *
* Software by:                Simple Machines (http://www.simplemachines.org) *
* Copyright 2001-2006 by:     Lewis Media (http://www.lewismedia.com)         *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

class twoco
{
	// Validate this is valid for this transaction type.
	function precheck()
	{
		global $modSettings, $twoco_pw, $txt;

		// Is this the right hash?
		if (empty($twoco_pw) || $_POST['x_MD5_Hash'] != strtoupper(md5($twoco_pw . $modSettings['2co_id'] . $_POST['x_trans_id'] . $_POST['x_amount'])))
		{
			generateError($txt['2co_password_wrong']);
		}

		// Can't exist if it doesn't contain anything.
		if (empty($_POST['x_invoice_num']))
			exit;

		// Verify the currency
		list (, $currency) = explode(':', $_POST['x_invoice_num']);

		// Verify the currency!
		if (strtolower($currency) != $modSettings['currency_code'])
			exit;

		// Return the ID_SUB/ID_MEMBER
		return explode('+', $_POST['x_invoice_num']);
	}

	// Is this a refund?
	function isRefund()
	{
		return false;
	}

	// Is this a subscription?
	function isSubscription()
	{
		return false;
	}

	// Is this a normal payment?
	function isPayment()
	{
		// We have to assume so?
		return true;
	}

	// How much was paid?
	function getCost()
	{
		return $_POST['x_amount'];
	}

	// Redirect the user away.
	function close()
	{
		redirectexit();
	}
}

?>