<?php
/******************************************************************************
* nochex.php                                                                  *
*******************************************************************************
* SMF: Simple Machines Forum                                                  *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1 Beta 4                                  *
* Software by:                Simple Machines (http://www.simplemachines.org) *
* Copyright 2001-2006 by:     Lewis Media (http://www.lewismedia.com)         *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

class nochex
{
	var $return_data;

	// Validate this is valid for this transaction type.
	function precheck()
	{
		global $modSettings, $txt, $webmaster_email;
	
		// Build the request string...
		$requestString = '';	
		// Now my dear, add all the posted bits.
		foreach ($_POST as $k => $v)
		{
			// Append the string.
			$requestString .= '&' . $k . '=' . urlencode($v);
		}
	
		// Can we use curl?
		if (function_exists('curl_init') && $curl = curl_init('https://www.nochex.com/nochex.dll/apc/apc'))
		{
			// Set the post data.	
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDSIZE, 0);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $requestString);
		
			// Fetch the data returned as a string.
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
		
			// Fetch the data.
			$this->return_data = curl_exec($curl);
		
			// Close the session.
			curl_close($curl);
		}
		// Otherwise good old HTTP.
		else
		{
			// Setup the headers.
			$header = "POST /nochex.dll/apc/apc HTTP/1.0\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$header .= "Content-Length: " . strlen ($requestString) . "\r\n\r\n";
		
			// Open the connection.
			$fp = fsockopen('ssl://www.nochex.com', 443, $errno, $errstr, 30);
		
			// Did it work?
			if (!$fp)
				generateError($txt['nochex_could_not_connect']);
		
			// Put the data to the port.
			fputs($fp, $header . $requestString);
		
			// Get the data back...
			while (!feof($fp))
			{
				$this->return_data = fgets($fp, 1024);
				if (strcmp($this->return_data, 'AUTHORISED') == 0)
					break;
			}
		
			// Clean up.
			fclose($fp);
		}
	
		// If this isn't verified then give up...
		if (strcmp($this->return_data, 'AUTHORISED') != 0)
		{
			// Send an email.
			sendmail($webmaster_email, $txt['nochex_unauthorised_subject'], $txt['nochex_unauthorised_body']);
			exit;
		}
	
		// Can't exist if it doesn't contain anything.
		if (empty($_POST['order_id']))
			exit;

		// Return the ID_SUB and ID_MEMBER
		return explode('+', $_POST['order_id']);
	}

	// Is this a refund?
	function isRefund()
	{
		return false;
	}

	// Is this a subscription?
	function isSubscription()
	{
		return false;
	}

	// Is this a normal payment?
	function isPayment()
	{
		return true;
	}

	// How much was paid?
	function getCost()
	{
		return $_POST['amount'];
	}

	// exit.
	function close()
	{
		exit();
	}
}

?>