<?php
/******************************************************************************
* paidsubsDBDE.php	                                                      *
*******************************************************************************
* SMF: Simple Machines Forum - Ultimate Shoutbox MOD                          *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           0.1	                                      *
* Written By: 		      Matthew Wolf (a.k.a Grudge)                     *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

// The main table.
$sub_columns = array(
	array('name' => 'id_subscribe', 'type' => 'int', 'size' => 10, 'null' => false, 'auto' => true),
	array('name' => 'name', 'type' => 'varchar', 'size' => 60, 'null' => false, 'default' => ''),
	array('name' => 'description', 'type' => 'tinytext', 'null' => false, 'default' => ''),
	array('name' => 'cost', 'type' => 'text', 'null' => false, 'default' => ''),
	array('name' => 'length', 'type' => 'varchar', 'size' => 6, 'null' => false, 'default' => ''),
	array('name' => 'id_group', 'type' => 'mediumint', 'size' => 8, 'null' => false, 'default' => '0'),
	array('name' => 'addgroups', 'type' => 'varchar', 'size' => 40, 'null' => false, 'default' => ''),
	array('name' => 'active', 'type' => 'tinyint', 'size' => 3, 'null' => false, 'default' => '1'),
	array('name' => 'repeatable', 'type' => 'tinyint', 'size' => 3, 'null' => false, 'default' => '0'),
	array('name' => 'allowpartial', 'type' => 'tinyint', 'size' => 3, 'null' => false, 'default' => '0'),
	array('name' => 'reminder', 'type' => 'int', 'tinyint' => 3, 'null' => false, 'default' => '0'),
	array('name' => 'email_complete', 'type' => 'text', 'null' => false, 'default' => ''),
);

$sub_indexes = array(
	array('type' => 'primary', 'columns' => array('id_subscribe')),
	array('name' => 'active', 'type' => 'index', 'columns' => array('active')),
);
$smfFunc['db_create_table']("{$db_prefix}subscriptions", $sub_columns, $sub_indexes, array(), 'update');

// The log table.
$log_columns = array(
	array('name' => 'id_sublog', 'type' => 'int', 'size' => 10, 'null' => false, 'auto' => true),
	array('name' => 'id_subscribe', 'type' => 'int', 'size' => 10, 'null' => false, 'default' => '0'),
	array('name' => 'id_member', 'type' => 'int', 'size' => 10, 'null' => false, 'default' => '0'),
	array('name' => 'old_id_group', 'type' => 'mediumint', 'size' => 8, 'null' => false, 'default' => '0'),
	array('name' => 'starttime', 'type' => 'int', 'size' => 10, 'null' => false, 'default' => '0'),
	array('name' => 'endtime', 'type' => 'int', 'size' => 10, 'null' => false, 'default' => '0'),
	array('name' => 'status', 'type' => 'tinyint', 'size' => 3, 'null' => false, 'default' => '0'),
	array('name' => 'reminder_sent', 'type' => 'tinyint', 'size' => 3, 'null' => false, 'default' => '0'),
);

$log_indexes = array(
	array('type' => 'primary', 'columns' => array('id_sublog')),
	array('name' => 'id_subscribe', 'type' => 'unique', 'columns' => array('id_subscribe', 'id_member')),
	array('name' => 'id_user', 'type' => 'index', 'columns' => array('id_member')),
);
$smfFunc['db_create_table']("{$db_prefix}log_subscribed", $log_columns, $log_indexes, array(), 'update');

// Settings
$toSet = array(
	array("'paid_enabled'", "'0'"),
	array("'paypal_email'", "''"),
	array("'worldpay_id'", "''"),
	array("'paidNextExpire'", "'2222222222'"),
);

// Insert settings
$smfFunc['db_insert']('ignore',
	"{$db_prefix}settings",
	array('variable', 'value'),
	$toSet,
	array('variable')
);

?>