<edit file>
$boarddir/index.php
</edit file>

<search for>
	loadPermissions();
</search for>

<add after>
	// Should we check paid subscriptions?
	if (empty($modSettings['paidNextExpire']) || time() > $modSettings['paidNextExpire'])
	{
		require_once($sourcedir . '/ManagePaid.php');
		loadLanguage('ManagePaid');
		autoCheckSubscriptions();
	}
</add after>

<search for>
		'post' => array('Post.php', 'Post'),
</search for>

<add before>
		'paidsubscribe' => array('ManagePaid.php', 'ManagePaidSubscriptions'),
</add before>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
			$context['admin_areas']['members']['areas']['ban_members'] = '<a href="' . $scripturl . '?action=ban">' . $txt['ban_title'] . '</a>';
</search for>

<add before>
		if (allowedTo('admin_forum'))
			$context['admin_areas']['members']['areas']['paid_subscriptions'] = '<a href="' . $scripturl . '?action=paidsubscribe">' . $txt['paid_subscriptions'] . '</a>';
</add before>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
		'deleteAccount' => array(array('profile_remove_any', 'profile_remove_own'), array('profile_remove_any')),
</search for>

<add before>
		'subscriptions' => array(array('moderate_forum', 'profile_view_own'), array('moderate_forum')),
</add before>

<search for>
	// If you have permission to do something with this profile, you'll see one or more actions.
</search for>

<add before>
	// Add paid subscriptions.
	elseif (!empty($modSettings['paid_enabled']) && (($context['user']['is_owner'] && allowedTo('profile_view_own')) || allowedTo('moderate_forum')))
	{
		// This is needed incase user can't edit profile.
		$context['profile_areas']['edit_profile'] = array(
			'title' => $txt['profileEdit'],
			'areas' => array()
		);
	}

	// Now the real paid subscriptions.
	if (!empty($modSettings['paid_enabled']) && (($context['user']['is_owner'] && allowedTo('profile_view_own')) || allowedTo('moderate_forum')))
		$context['profile_areas']['edit_profile']['areas']['subscriptions'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=subscriptions">' . $txt['paid_subscriptions'] . '</a>';
</add before>

<search for>
?>
</search for>

<add before>
// Function for doing all the paid subscription stuff - kinda.
function subscriptions($memID)
{
	global $context, $txt, $sourcedir, $db_prefix, $modSettings;

	// Load the paid template anyway.
	loadTemplate('ManagePaid');
	loadLanguage('ManagePaid');

	// Simple "done"?
	if (isset($_GET['done']))
	{
		$_GET['sub_id'] = (int) $_GET['sub_id'];

		// Setup a pending entry if they haven't got anything.
		db_query("
			INSERT IGNORE INTO {$db_prefix}log_subscribed
				(ID_SUBSCRIBE, ID_MEMBER, status, startTime)
			VALUES
				($_GET[sub_id], $memID, 0, " . time() . ")", __FILE__, __LINE__);

		$context['sub_template'] = 'paid_done';
		return;
	}

	// Load all subscriptions
	$request = db_query("
		SELECT ID_SUBSCRIBE, name, description, cost, length, active, repeatable
		FROM {$db_prefix}subscriptions", __FILE__, __LINE__);
	$context['subscriptions'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// Pick a cost.
		$costs = @unserialize($row['cost']);

		$cost_array = array();

		if ($row['length'] == 'F')
		{
			foreach ($costs as $duration => $cost)
			{
				if ($cost != 0)
					$cost_array[$duration] = $cost;
			}
		}
		else
		{
			$cost_array['fixed'] = $costs['fixed'];
		}

		if (empty($cost_array))
			continue;
	
		// Do the span.
		preg_match('~(\d*)(\w)~', $row['length'], $match);
		if (isset($match[2]))
		{
			$length = $match[1] . ' ';
			switch ($match[2])
			{
				case 'D':
					$length .= $txt['paid_mod_span_days'];
					break;
				case 'W':
					$length .= $txt['paid_mod_span_weeks'];
					break;
				case 'M':
					$length .= $txt['paid_mod_span_months'];
					break;
				case 'Y':
					$length .= $txt['paid_mod_span_years'];
					break;
			}
		}
		else
			$length = '??';

		$context['subscriptions'][$row['ID_SUBSCRIBE']] = array(
			'id' => $row['ID_SUBSCRIBE'],
			'name' => $row['name'],
			'desc' => $row['description'],
			'costs' => $cost_array,
			'length' => $length,
			'real_length' => $row['length'],
			'member' => 0,
			'active' => $row['active'] && !empty($modSettings['paid_enabled']),
			'flexible' => $row['length'] == 'F' ? true : false,
			'subscribed' => false,
			'repeatable' => $row['repeatable'],
		);
	}
	mysql_free_result($request);

	// If this is confirmation then it's simpler...
	if (isset($_GET['confirm']) && isset($_POST['sub_id']) && is_array($_POST['sub_id']))
	{
		if (empty($modSettings['paid_enabled']) || (empty($modSettings['paypal_email']) && empty($modSettings['worldpay_id']) && empty($modSettings['2co_id']) && empty($modSettings['nochex_email']) && empty($modSettings['authorize_id'])))
			fatal_lang_error('paid_disabled');

		// Hopefully just one.
		foreach ($_POST['sub_id'] as $k => $v)
			$ID_SUB = (int) $k;

		if (!isset($context['subscriptions'][$ID_SUB]) || $context['subscriptions'][$ID_SUB]['active'] == 0)
			fatal_lang_error('paid_sub_not_active');

		// Simplify...
		$context['sub'] = $context['subscriptions'][$ID_SUB];

		// Check we have a valid cost.
		if ($context['sub']['flexible'] && (!isset($_POST['cur'][$ID_SUB]) || !isset($context['sub']['costs'][$_POST['cur'][$ID_SUB]])))
			fatal_lang_error('paid_sub_not_active');

		// Sort out the cost/currency.
		$context['currency'] = $modSettings['currency_code'];
		$context['recur'] = $context['sub']['repeatable'];

		if ($context['sub']['flexible'])
		{
			// Real cost...
			$context['value'] = $context['sub']['costs'][$_POST['cur'][$ID_SUB]];
			$context['cost'] = sprintf($txt[$context['currency'] . '_symbol'], $context['value']) . '/' . $txt[$_POST['cur'][$ID_SUB]];
			// The period value for paypal.
			$context['paypal_period'] = strtoupper(substr($_POST['cur'][$ID_SUB], 0, 1));
		}
		else
		{
			// Real cost...
			$context['value'] = $context['sub']['costs']['fixed'];
			$context['cost'] = sprintf($txt[$context['currency'] . '_symbol'], $context['value']);

			// Recur?
			preg_match('~(\d*)(\w)~', $context['sub']['real_length'], $match);
			$context['paypal_unit'] = $match[1];
			$context['paypal_period'] = $match[2];
		}

		// Change the template.
		$context['sub_template'] = 'choose_payment';

		// Quit.
		return;
	}
	else
		$context['sub_template'] = 'user_subscription';

	// Get the current subscriptions.
	$request = db_query("
		SELECT ID_SUBLOG, ID_SUBSCRIBE, startTime, endTime, status
		FROM {$db_prefix}log_subscribed
		WHERE ID_MEMBER = $memID", __FILE__, __LINE__);
	$context['current'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// The subscription must exist!
		if (!isset($context['subscriptions'][$row['ID_SUBSCRIBE']]))
			continue;

		$context['current'][] = array(
			'id' => $row['ID_SUBLOG'],
			'sub_id' => $row['ID_SUBSCRIBE'],
			'name' => $context['subscriptions'][$row['ID_SUBSCRIBE']]['name'],
			'start' => timeformat($row['startTime'], false),
			'end' => timeformat($row['endTime'], false),
			'status' => $row['status'],
			'status_text' => $row['status'] == 0 ? $txt['paid_pending'] : ($row['status'] == 1 ? $txt['paid_finished'] : $txt['paid_active']),
		);

		if ($row['status'] == 2)
			$context['subscriptions'][$row['ID_SUBSCRIBE']]['subscribed'] = true;
	}
	mysql_free_result($request);
}
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
// Paid Subscriptions Mod
$txt['paid_subscriptions'] = 'Paid Subscriptions';
$txt['subscriptions'] = 'Subscriptions';
$txt['subscription'] = 'Subscription';
$txt['paid_subs_desc'] = 'Below is a list of all the subscriptions which are available on this forum.';
$txt['paid_subs_none'] = 'There are currently no paid subscriptions available!';

$txt['paid_current'] = 'Existing Subscriptions';

// Some errors.
$txt['paypal_could_not_connect'] = 'Could not connect to paypal server';
$txt['paypal_unverified_subject'] = 'Unverified Paypal Transaction';
$txt['paypal_unverified_body'] = 'A user attempted to add a paid subscription to your forum, but the transaction was unverified.';
$txt['paid_sub_not_active'] = 'That subscription is not taking any new users!';
$txt['paid_disabled'] = 'Paid subscriptions are currently disabled!';
$txt['worldpay_password_wrong'] = 'Payment ignored as WorldPay password is incorrect - please ensure you have the correct callback password set.';
$txt['2co_password_wrong'] = 'Payment ignored as 2co.com secret word is incorrect - please ensure you have the correct secret word and 2co.com ID set.';
$txt['paid_unknown_transaction_type'] = 'Unknown transaction type in ipn.php';
$txt['paid_missing_transaction_type'] = 'Cannot find transaction file %s.php';
$txt['paid_empty_member'] = 'Paid subscription handler could not recover member ID';
$txt['paid_could_not_find_member'] = 'Paid subscription handler could not find member with ID: %d';
$txt['paid_count_not_find_subscription'] = 'Paid subscription handler could not find subscription for member ID: %1$s, subscription ID: %2$s';
$txt['nochex_could_not_connect'] = 'Could not connect to nochex server';
$txt['nochex_unauthorised_subject'] = 'Unauthorised nochex Transaction';
$txt['nochex_unauthorised_body'] = 'A user attempted to add a paid subscription to your forum, but the transaction was rejected.';
</add before>