<?php
/******************************************************************************
* paidsubsdb.php	                                                          *
*******************************************************************************
* SMF: Simple Machines Forum - Ultimate Shoutbox MOD                          *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           0.1	                                          *
* Written By: 			      Matthew Wolf (a.k.a Grudge)    		          *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

// Table for the main subscriptions.
db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}subscriptions(
	ID_SUBSCRIBE int(11) NOT NULL auto_increment,
	Name varchar(60) NOT NULL default '',
	Description tinytext NOT NULL,
	Cost text NOT NULL default '',
	Length varchar(6) NOT NULL default '',
	ID_GROUP int(8) NOT NULL default '0',
	addGroups varchar(40) NOT NULL default '',
	active tinyint(3) NOT NULL default '1',
	Repeatable tinyint(3) NOT NULL default '0',
	allowPartial tinyint(3) NOT NULL default '0',
	reminder tinyint(4) NOT NULL default '0',
	email_complete text NOT NULL default '',
	PRIMARY KEY  (ID_SUBSCRIBE),
	KEY active (active)
) TYPE=MyISAM", __FILE__, __LINE__);

// Table for the logs
db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}log_subscribed(
	ID_SUBLOG int(10) NOT NULL auto_increment,
	ID_SUBSCRIBE int(10) NOT NULL default '0',
	ID_MEMBER int(10) NOT NULL default '0',
	OLD_ID_GROUP int(8) NOT NULL default '0',
	startTime int(10) NOT NULL default '0',
	endTime int(10) NOT NULL default '0',
	status tinyint(3) NOT NULL default '0',
	reminder_sent tinyint(3) NOT NULL default '0',
	PRIMARY KEY  (ID_SUBLOG),
	UNIQUE KEY ID_SUBSCRIBE (ID_SUBSCRIBE,ID_MEMBER),
	KEY ID_USER (ID_MEMBER)
) TYPE=MyISAM", __FILE__, __LINE__);

// For upgrades.
db_query("
	ALTER TABLE {$db_prefix}subscriptions
	CHANGE COLUMN Cost Cost text NOT NULL default ''", __FILE__, __LINE__);

db_query("
	ALTER TABLE {$db_prefix}subscriptions
	CHANGE COLUMN Description Description text NOT NULL", __FILE__, __LINE__);

$request = db_query("
	SHOW COLUMNS
	FROM {$db_prefix}subscriptions", __FILE__, __LINE__);
$new_cols = array('repeatable', 'reminder', 'email_complete', 'allowpartial');
$new_cols = array_flip($new_cols);
while ($request && $row = mysql_fetch_row($request))
{
	$row[0] = strtolower($row[0]);
	if (isset($new_cols[$row[0]]))
		unset($new_cols[$row[0]]);
}
if ($request)
	mysql_free_result($request);

if (isset($new_cols['repeatable']))
	db_query("
		ALTER TABLE {$db_prefix}subscriptions
		ADD COLUMN Repeatable tinyint(3) NOT NULL default '0'", __FILE__, __LINE__);
if (isset($new_cols['reminder']))
	db_query("
		ALTER TABLE {$db_prefix}subscriptions
		ADD COLUMN reminder tinyint(4) NOT NULL default '0'", __FILE__, __LINE__);
if (isset($new_cols['email_complete']))
	db_query("
		ALTER TABLE {$db_prefix}subscriptions
		ADD COLUMN email_complete text NOT NULL default ''", __FILE__, __LINE__);
if (isset($new_cols['allowpartial']))
	db_query("
		ALTER TABLE {$db_prefix}subscriptions
		ADD COLUMN allowPartial tinyint(3) NOT NULL default '0'", __FILE__, __LINE__);

$request = db_query("
	SHOW COLUMNS
	FROM {$db_prefix}log_subscribed", __FILE__, __LINE__);
$new_cols = array('reminder_sent');
$new_cols = array_flip($new_cols);
while ($request && $row = mysql_fetch_row($request))
{
	if (isset($new_cols[$row[0]]))
		unset($new_cols[$row[0]]);
}
if ($request)
	mysql_free_result($request);

if (isset($new_cols['reminder_sent']))
	db_query("
		ALTER TABLE {$db_prefix}log_subscribed
		ADD COLUMN reminder_sent tinyint(3) NOT NULL default '0'", __FILE__, __LINE__);

// Settings
$toSet = array();
$toSet['paid_enabled'] = '0';
$toSet['paypal_email'] = '';
$toSet['worldpay_id'] = '';
$toSet['paidNextExpire'] = '2222222222';

// Insert settings
foreach ($toSet as $key => $value){
	db_query("INSERT IGNORE INTO
		{$db_prefix}settings
		(`variable`, `value`)
		VALUES ('$key', '$value')", __FILE__, __LINE__);
}

?>