<?php
/******************************************************************************
* worldpay.php                                                                *
*******************************************************************************
* SMF: Simple Machines Forum                                                  *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1 Beta 4                                  *
* Software by:                Simple Machines (http://www.simplemachines.org) *
* Copyright 2001-2006 by:     Lewis Media (http://www.lewismedia.com)         *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

class worldpay
{
	// Validate this is valid for this transaction type.
	function precheck()
	{
		global $modSettings;

		// Just incase.
		if (empty($modSettings['worldpay_id']))
			exit;
	
		// Wrong ID?
		if ($_POST['instId'] != $modSettings['worldpay_id'])
			exit;
	
		// Can't exist if it doesn't contain anything.
		if (empty($_POST['cartId']))
			exit;

		// Verify the currency!
		if (strtolower($_POST['currency']) != $modSettings['currency_code'])
			exit;

		// Return the ID_SUB/ID_MEMBER
		return explode('+', $_POST['cartId']);
	}

	// Is this a refund?
	function isRefund()
	{
		if ($_POST['transStatus'] != 'Y')
			return true;
		else
			return false;
	}

	// Is this a subscription?
	function isSubscription()
	{
		return false;
	}

	// Is this a normal payment?
	function isPayment()
	{
		if ($_POST['authMode'] != 'E')
			return true;
		else
			return false;
	}

	// How much was paid?
	function getCost()
	{
		return $_POST['cost'];
	}

	// exit.
	function close()
	{
		exit();
	}
}

?>